SystemOrganization addCategory: #Metaprogramacion!

TestCase subclass: #MetaProgramacionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MetaProgramacionTest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/19/2013 20:11'!
test01NonAbstractMethodShouldReturnEmptyCollection
	"comment stating purpose of message"
	
	| xxx |

	xxx:= MissingImplementorsChecker new.
		
	self assert: (xxx check: ClaseNoAbstracta  forMissingImplementorsOf: #metodo) isEmpty 
	! !

!MetaProgramacionTest methodsFor: 'as yet unclassified' stamp: 'EmilianoEzequielNicols 6/20/2013 16:29'!
test02ShouldRaiseAnExceptionWhenMethodNotInMethodDictionary
	"comment stating purpose of message"
	
	| xxx |

	xxx:= MissingImplementorsChecker new.
		
	self should:  [xxx check: ClaseNoAbstracta  forMissingImplementorsOf: #methodNotFound]
		raise: Error
		withExceptionDo: [ :anError | self assert: (anError messageText = 'method not implemented in class') ] 
	! !

!MetaProgramacionTest methodsFor: 'as yet unclassified' stamp: 'EmilianoEzequielNicols 6/20/2013 16:15'!
test03AbstractMethodShouldReturnGrandChildrenThatDontImplementIt
	"comment stating purpose of message"
	
	| xxx children |

	xxx:= MissingImplementorsChecker new.
	
	children := 	(xxx check: ClaseAbstracta forMissingImplementorsOf: #abstractMethod).
		
	self assert:  ( (children size = 1) and: [ (children at: 1) = (NietaQueNoImplementaDeHijaQueNo) ])
		! !

!MetaProgramacionTest methodsFor: 'as yet unclassified' stamp: 'EmilianoEzequielNicols 6/20/2013 17:39'!
test04ChildrenListIsEmptyWhenAbstractMethodNoSubclasses
	
	| xxx children |
	
	xxx := MissingImplementorsChecker  new.
			
	children := xxx check: ClaseAbstractaSinSubclases forMissingImplementorsOf:#abstractMethod. 
	
	self assert: children isEmpty 
	! !

Object subclass: #ClaseAbstracta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClaseAbstracta methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/19/2013 20:18'!
abstractMethod

	^self subclassResponsibility ! !

ClaseAbstracta subclass: #HijaQueImplementa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!HijaQueImplementa methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/19/2013 20:20'!
abstractMethod 
	^true! !

HijaQueImplementa subclass: #NietaQueImplementa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

NietaQueImplementa subclass: #BisnietaQueNoImplementa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!NietaQueImplementa methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/19/2013 21:15'!
abstractMethod 
	 ^true ! !

HijaQueImplementa subclass: #NietaQueNoImplementa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ClaseAbstracta subclass: #HijaQueNoImplementa
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

HijaQueNoImplementa subclass: #NietaQueImplementaDeHijaQueNo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!NietaQueImplementaDeHijaQueNo methodsFor: 'as yet unclassified' stamp: 'EmilianoEzequielNicols 6/20/2013 15:49'!
abstractMethod 
	^true! !

HijaQueNoImplementa subclass: #NietaQueNoImplementaDeHijaQueNo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

Object subclass: #ClaseAbstractaSinSubclases
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClaseAbstractaSinSubclases methodsFor: 'as yet unclassified' stamp: 'EmilianoEzequielNicols 6/20/2013 17:39'!
abstractMethod
	
	^true! !

Object subclass: #ClaseNoAbstracta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!ClaseNoAbstracta methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 6/19/2013 19:49'!
metodo

	^true! !

Object subclass: #MissingImplementorsChecker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MissingImplementorsChecker methodsFor: 'as yet unclassified' stamp: 'EmilianoEzequielNicols 6/20/2013 17:11'!
check: aClass forMissingImplementorsOf: aSelector 
	
	 | methodDict  listaDeSubclases|
	
	methodDict := aClass methodDict.
	
	methodDict at: aSelector ifAbsent: [^Error signal: 'method not implemented in class'  ].
 	
	((aClass methodDict at: aSelector) isAbstract) ifFalse: [^ LinkedList new ]. 
	
	^ (aClass allSubclasses ) select: [ :aSubclass | (self isLeaf: aSubclass) and: [(aSubclass canPerform: aSelector)not] ]
	
		
! !

!MissingImplementorsChecker methodsFor: 'as yet unclassified' stamp: 'EmilianoEzequielNicols 6/20/2013 17:00'!
isLeaf: aClass

	^aClass subclasses isEmpty! !
